/******************************************************************************/
/*                                                                            */
/* Note: This plugin node implementation is not necessarily portable          */
/* to all platforms supported by MQSeries Integrator Version 2.               */
/*                                                                            */
/******************************************************************************/
/* Includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <wchar.h>
#include <ctype.h>

#include "node_utils.h"


/* 19/07/2001 */
CciChar *ASCIIToUnicode(const char *aStr)
{
   size_t len	= strlen(aStr);
	int rc		= -1;

   CciChar *outStr = (CciChar *)malloc(sizeof(CciChar) * (len + 1));
	(void)cciMbsToUcs(&rc, aStr, outStr, len + 1, 1208) ;

   outStr[len] = 0;

   return outStr;
}


/* 19/07/2001 */
char *UnicodeToASCII(const CciChar *lStr)
{
	int rc = -1;

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001 */
	unsigned int len = CciCharLen(lStr);
#else
	size_t len = wcslen(lStr);
#endif
   char *outStr = (char *)malloc(sizeof(char) * (len + 1));
   (void)cciUcsToMbs(&rc, lStr, outStr, len + 1, 1208);

	outStr[len] = (char)0;
	return outStr;
}

/* wchar_t *ASCIIToUnicode(const char* aStr)*/
/**/
/*{*/
/*  unsigned int len = strlen(aStr);*/
/*  wchar_t* outStr = (wchar_t *)malloc(sizeof(wchar_t) * (len + 1));*/
/*  mbstowcs(outStr, aStr, len + 1);*/
/*  outStr[len] = L'\0';*/
/*  return outStr;*/
/*}*/


/*char *UnicodeToASCII(const wchar_t* lStr)*/
/**/
/*{*/
/*  unsigned int len = wcslen(lStr);*/
/*  char *outStr = (char *)malloc(sizeof(char) * (len + 1));*/
/*  wcstombs(outStr, lStr, len + 1);*/
/*  outStr[len] = '\0';*/
/*  return outStr;*/
/*}*/


NodeStringBuffer* NodeStringBufferAlloc(void)
{
	NodeStringBuffer *retVal = (NodeStringBuffer *)malloc(sizeof(NodeStringBuffer));

	if (retVal == NULL) {
		fprintf(stderr, "Allocation Failed raised at %s:%d\n", __FILE__, __LINE__);
		fprintf(stderr, "aborting...\n");
		(void)fflush(stderr);
		abort();
	}

	retVal->size    = CHAR_ALLOC_SIZE;
	retVal->length  = 0;
	retVal->buf     = (char *)malloc(CHAR_ALLOC_SIZE);

  	if (retVal->buf == NULL) {
		fprintf(stderr, "Allocation Failed raised at %s:%d\n", __FILE__, __LINE__);
		fprintf(stderr, "aborting...\n");
		(void)fflush(stderr);
		abort();
	} /*  if (retVal->buf == NULL) */

  return retVal;
}


void NodeStringBufferFree(NodeStringBuffer *buf)
{
  free(buf->buf);
  free(buf);

  return;
}


static void NodeStringBufferResize(NodeStringBuffer *buf, size_t len)
{
   if ((buf->length + len + 1) >= buf->size) {
	   buf->size *= 2;
	   if ((buf->length + len + 1) >= buf->size) {
	      buf->size += (len + 1);
	   }

	   buf->buf = (char *)realloc(buf->buf, buf->size);

		if (buf->buf == NULL) {
			fprintf(stderr, "Allocation Failed raised at %s:%d\n", __FILE__, __LINE__);
			fprintf(stderr, "aborting...\n");
			(void)fflush(stderr);
			abort();
		}

   }

   return;
}


void NodeStringBufferAdd(NodeStringBuffer *buf, const char *str)
{
  size_t len = strlen(str);

  NodeStringBufferResize(buf, len);
  strcpy(&(buf->buf[buf->length]), str);
  buf->length += len;

  return;
}


void NodeStringBufferAddChar(NodeStringBuffer *buf, const char c)
{
  NodeStringBufferResize(buf, 2);
  buf->buf[buf->length] = c;
  buf->length++;
  buf->buf[buf->length] = '\0';
}
